classdef cAprilTagFinderLog < handle
  properties
    tags=[];
    K=[];
    distCoeffs=[];
    tmap=[];
  end
  methods
    function obj=cAprilTagFinderLog(fpath)
      %fpath: file path to the log file generated by AprilTagFinder
      [folder,fname,~]=fileparts(fpath);
			logscript = fullfile(folder,fname);
			clear(logscript); % need to clear cache in matlab, see http://www.mathworks.com/matlabcentral/answers/102386
      run(logscript);
      tags2=cell2mat(tags); %tags{1} => tags(1)
      ids=cat(2,tags2.id);
      obj.tmap=containers.Map(ids,tags);
      obj.tags=tags2;
      obj.K=K;
      obj.distCoeffs=distCoeffs;
    end
    
    function varargout=find(obj,varargin)
      n=length(varargin);
      
      for i=1:n
        varargout{i}=obj.tmap(varargin{i});
      end
    end
  end
end