classdef cDisjointset < handle
  properties
    DS=[];
  end
  methods
    function obj=cDisjointset(n)
      obj.DS = disjointsetMAKE(n);
    end
    
    function rx=find(obj,x)
      [obj.DS,rx]=disjointsetFIND(obj.DS,x);
    end
    
    function rr=union(obj,x,y)
      [obj.DS,rr]=disjointsetUNION(obj.DS,x,y);
    end
    
    function sz=findSize(obj,x)
      sz=obj.DS.size(find(obj,x));
    end
    
    function display(obj)
      disp(obj.DS);
    end
  end
end

%% private function
function DS = disjointsetMAKE(n)
DS.root=1:n;
DS.size=ones(1,n);
end

function [DS,rx]=disjointsetFIND(DS,x)
rx=DS.root(x);
if(x~=rx)
  [DS,rx]=disjointsetFIND(DS,rx);
  DS.root(x)=rx;
end
end

function [DS,rr] = disjointsetUNION(DS,x,y)
[DS,rx]=disjointsetFIND(DS,x);
[DS,ry]=disjointsetFIND(DS,y);
if(rx==ry)
  rr=rx;
  return;
end

if(DS.size(rx)<DS.size(ry))
  DS.root(rx)=ry;
  DS.size(ry)=DS.size(ry)+DS.size(rx);
  rr=ry;
else
  DS.root(ry)=rx;
  DS.size(rx)=DS.size(rx)+DS.size(ry);
  rr=rx;
end
end