function [tim,mask]=imWarp(im,H,w,h,needInvH)
% project im<sxt> to tim<hxw> using H so that x_tim=H*x_im
% mask<hxw>: mask(y,x)==1 for valid region in tim

% we need to sample tim from im with xs,ys
% which are projected from xi,yi by inv(H)
% note: x_tim=[xs,ys], x_im=[xi,yi]
assert(size(H,1)==3 && size(H,2)==3);

if nargin<5
  needInvH=true;
end
if needInvH
  H = inv(H);
end

[xi,yi]=meshgrid(1:w,1:h);
ws=(H(3,1)*xi+H(3,2)*yi+H(3,3));
xs=(H(1,1)*xi+H(1,2)*yi+H(1,3));
ys=(H(2,1)*xi+H(2,2)*yi+H(2,3));
xs=xs./ws;
ys=ys./ws;
[hi,wi]=size(im);
if nargout>1
  mask=(xs>=1 & ys>=1 & xs<=wi & ys<=hi);
end
tim=uint8(interp2(double(im), xs, ys));
end

%% I used this before, need to compare which implementation is better
% tim=uint8(zeros(w,h));
% tf=maketform('projective',H'); %remember tf is U'=X'*H'
% [sub,xda,yda]=imtransform(im,tf,'bicubic');
% x1=round(xda(1)); x2=round(xda(2));
% y1=round(yda(1)); y2=round(yda(2));
% tim(y1:y2,x1:x2)=sub;
