function J=nuJacobian(hfunc, X0, step)
% numerical jacobian
% hfunc <function handle,R^n=>R^m>: handle to a function
% X0 <nx1>: jacobian will be evaluated at X0
% step [1x1,1e-5]: step size
% J <mxn>: computed jacobian matrix
assert(size(X0,2)==1);
F0=hfunc(X0);
assert(size(F0,2)==1);
n=size(X0,1); % number of vars
m=size(F0,1); % number of returns

if nargin<3
  step=1e-5;
end

J=zeros(m,n);
Xi=X0;
for i=1:n
  Xi(i)=X0(i)+step;
  J(:,i)=(hfunc(Xi)-F0)/step;
  Xi(i)=X0(i);
end
end